#ifndef EFL_FLIPABLE_EO_HH
#define EFL_FLIPABLE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_flipable.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { 
struct Flipable;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Flipable> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { 
struct Flipable {
   ::efl::eolian::return_traits<Efl_Flip>::type flip_get() const;
   ::efl::eolian::return_traits<void>::type flip_set( ::efl::eolian::in_traits<Efl_Flip>::type flip) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_FLIPABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::Flipable() const;
   operator ::efl::Flipable&();
   operator ::efl::Flipable const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Flipable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Flipable const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Flipable : ::efl::eo::concrete
{
   explicit Flipable( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Flipable(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Flipable(Flipable const& other) = default;
   Flipable(Flipable&& other) = default;
   Flipable& operator=(Flipable const& other) = default;
   Flipable& operator=(Flipable&& other) = default;
   Flipable()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Flipable( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Flipable(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<Efl_Flip>::type flip_get() const;
   ::efl::eolian::return_traits<void>::type flip_set( ::efl::eolian::in_traits<Efl_Flip>::type flip) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_FLIPABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Flipable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Flipable const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Flipable) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Flipable>::value, "");
} 
#include "efl_flipable.eo.impl.hh"
#endif
